LD1	MACRO	DEST,OP		;DEST:=OP
	movff	OP,DEST
	ENDM

LD2	MACRO	DEST,OP
	LD1	DEST,OP
	movff	OP+1,DEST+1
	ENDM
;
LD3	MACRO	DEST,OP
	LD2	DEST,OP
	movff	OP+2,DEST+2
	ENDM

LD4	MACRO	DEST,OP
	LD3	DEST,OP
	movff	OP+3,DEST+3
	ENDM

LD5	MACRO	DEST,OP
	LD4	DEST,OP
	movff	OP+4,DEST+4
	ENDM
;
LD6	MACRO	DEST,OP
	LD5	DEST,OP
	movff	OP+5,DEST+5
	ENDM
;................................
ADD1	MACRO	DEST,OP		;DEST = DEST + OP
	movf	OP,W
	addwf	DEST,F
	ENDM

ADD2	MACRO	DEST,OP		;DEST = DEST + OP
	ADD1	DEST,OP
	movf	OP+1,W
        addwfc	DEST+1,F
	ENDM

ADD3	MACRO	DEST,OP		;DEST = DEST + OP
	ADD2	DEST,OP
	movf	OP+2,W
        addwfc	DEST+2,F
	ENDM
;
ADD4	MACRO	DEST,OP		;DEST = DEST + OP
	ADD3	DEST,OP
	movf	OP+3,W
        addwfc	DEST+3,F
	ENDM
;
ADD5	MACRO	DEST,OP		;DEST = DEST + OP
	ADD4	DEST,OP
	movf	OP+4,W
        addwfc	DEST+4,F
	ENDM
;
ADD6	MACRO	DEST,OP		;DEST = DEST + OP
	ADD5	DEST,OP
	movf	OP+5,W
        addwfc	DEST+5,F
	ENDM
;................................
SUB1	MACRO	DEST,OP		;DEST = DEST - OP
	movf	OP,W
	subwf	DEST,F
	ENDM

SUB2	MACRO	DEST,OP		;DEST = DEST - OP
	SUB1	DEST,OP
	movf	OP+1,W
	subwfb	DEST+1,F
	ENDM
;
SUB3	MACRO	DEST,OP		;DEST = DEST - OP
	SUB2	DEST,OP
	movf	OP+2,W
	subwfb	DEST+2,F
	ENDM
;
SUB4	MACRO	DEST,OP		;DEST = DEST - OP
	SUB3	DEST,OP
	movf	OP+3,W
	subwfb	DEST+3,F
	ENDM
;
SUB5	MACRO	DEST,OP		;DEST = DEST - OP
	SUB4	DEST,OP
	movf	OP+4,W
	subwfb	DEST+4,F
	ENDM

SUB6	MACRO	DEST,OP		;DEST = DEST - OP
	SUB5	DEST,OP
	movf	OP+5,W
	subwfb	DEST+5,F
	ENDM
;................................
CMP1	MACRO	DEST,OP		;W:=DEST-OP
	movf	OP,W
	subwf	DEST,W
	ENDM
;
CMP2	MACRO	DEST,OP
	LOCAL	CEND
	movf	OP+1,W
	subwf	DEST+1,W
	bnz	CEND
	movf	OP,W
	subwf	DEST,W
CEND:
	ENDM

CMP3	MACRO	DEST,OP
	LOCAL	CEND
	movf	OP+2,W
	subwf	DEST+2,W
	bnz	CEND
	movf	OP+1,W
	subwf	DEST+1,W
	bnz	CEND
	movf	OP,W
	subwf	DEST,W
CEND	nop
	ENDM

CMP4	MACRO	DEST,OP        ; Low Byte first
	LOCAL	CEND
	movf	OP+3,W
	subwf	DEST+3,W
	bnz	CEND
	movf	OP+2,W
	subwf	DEST+2,W
	bnz	CEND
	movf	OP+1,W
	subwf	DEST+1,W
	bnz	CEND
	movf	OP,W
	subwf	DEST,W
CEND:
	ENDM

CMP5	MACRO	DEST,OP        ; Low Byte first
	LOCAL	CEND
	movf	OP+4,W
	subwf	DEST+4,W
	bnz	CEND
	movf	OP+3,W
	subwf	DEST+3,W
	bnz	CEND
	movf	OP+2,W
	subwf	DEST+2,W
	bnz	CEND
	movf	OP+1,W
	subwf	DEST+1,W
	bnz	CEND
	movf	OP,W
	subwf	DEST,W
CEND:	
	ENDM

CMP6	MACRO	DEST,OP        ; Low Byte first
	LOCAL	CEND
	movf	OP+5,W
	subwf	DEST+5,W
	bnz	CEND
	movf	OP+4,W
	subwf	DEST+4,W
	bnz	CEND
	movf	OP+3,W
	subwf	DEST+3,W
	bnz	CEND
	movf	OP+2,W
	subwf	DEST+2,W
	bnz	CEND
	movf	OP+1,W
	subwf	DEST+1,W
	bnz	CEND
	movf	OP,W
	subwf	DEST,W
CEND:	
	ENDM
;................................
FKGF1	macro	dest,op		;kleiner gleich
	CMP1	op,dest
	btfss	STATUS,C
	endm

FKGF2	macro	dest,op		;kleiner gleich
	CMP2	op,dest
	btfss	STATUS,C
	endm

FKGF3	macro	dest,op		;kleiner gleich
	CMP3	op,dest
	btfss	STATUS,C
	endm

FKGF4	macro	dest,op		;kleiner gleich
	CMP4	op,dest
	btfss	STATUS,C
	endm

FKGF5	macro	dest,op		;kleiner gleich
	CMP5	op,dest
	btfss	STATUS,C
	endm

FKGF6	macro	dest,op		;kleiner gleich
	CMP6	op,dest
	btfss	STATUS,C
	endm
;................................
FGRF1	macro	dest,op		;groesser
	CMP1	op,dest
	btfsc	STATUS,C
	endm

FGRF2	macro	dest,op		;groesser
	CMP2	op,dest
	btfsc	STATUS,C
	endm

FGRF3	macro	dest,op		;groesser
	CMP3	op,dest
	btfsc	STATUS,C
	endm

FGRF4	macro	dest,op		;groesser
	CMP4	op,dest
	btfsc	STATUS,C
	endm

FGRF5	macro	dest,op		;groesser
	CMP5	op,dest
	btfsc	STATUS,C
	endm

FGRF6	macro	dest,op		;groesser
	CMP6	op,dest
	btfsc	STATUS,C
	endm
;................................
FUGLF1	macro	dest,op		;ungleich
	CMP1	dest,op
	btfsc	STATUS,Z
	endm

FUGLF2	macro	dest,op		;ungleich
	CMP2	dest,op
	btfsc	STATUS,Z
	endm

FUGLF3	macro	dest,op		;ungleich
	CMP3	dest,op
	btfsc	STATUS,Z
	endm

FUGLF4	macro	dest,op		;ungleich
	CMP4	dest,op
	btfsc	STATUS,Z
	endm

FUGLF5	macro	dest,op		;ungleich
	CMP5	dest,op
	btfsc	STATUS,Z
	endm

FUGLF6	macro	dest,op		;ungleich
	CMP6	dest,op
	btfsc	STATUS,Z
	endm

FGLF1	macro	dest,op		;gleich
	CMP1	dest,op
	btfss	STATUS,Z
	endm

FGLF2	macro	dest,op		;gleich
	CMP2	dest,op
	btfss	STATUS,Z
	endm

FGLF3	macro	dest,op		;gleich
	CMP3	dest,op
	btfss	STATUS,Z
	endm

FGLF4	macro	dest,op		;gleich
	CMP4	dest,op
	btfss	STATUS,Z
	endm

FGLF5	macro	dest,op		;gleich
	CMP5	dest,op
	btfss	STATUS,Z
	endm

FGLF6	macro	dest,op		;gleich
	CMP6	dest,op
	btfss	STATUS,Z
	endm
;................................
LDK1	MACRO	DEST,KL		;DEST:=KL
	movlw	KL
	movwf	DEST
	ENDM
;................................
ADDK1	MACRO	DEST,KL		; DEST:=DEST+KL
	movlw	KL
	addwf	DEST,F
	ENDM
;................................
SUBK1	MACRO	DEST,KL		; DEST:=DEST-KL
	movlw	KL		;
	subwf	DEST,F		;
	ENDM			;
;...............................
SET2	macro	dest		;DEST = 0xFF
	setf	dest
	setf	dest+1
	endm

SET3	macro	dest
	SET2	dest
	setf	dest+2
	endm

SET4	macro	dest
	SET3	dest
	setf	dest+3
	endm

SET5	macro	dest
	SET4	dest
	setf	dest+4
	endm

SET6	macro	dest
	SET5	dest
	setf	dest+5
	endm
;................................
CLR2	MACRO	DEST		;DEST = 0
	clrf	DEST
	clrf	DEST+1
	ENDM

CLR3	MACRO	DEST
	clrf	DEST
	clrf	DEST+1
	clrf	DEST+2
	ENDM
;
CLR4	MACRO	DEST
	clrf	DEST
	clrf	DEST+1
	clrf	DEST+2
	clrf	DEST+3
	ENDM

CLR5	MACRO	DEST
	clrf	DEST
	clrf	DEST+1
	clrf	DEST+2
	clrf	DEST+3
	clrf	DEST+4
	ENDM

CLR6	MACRO	DEST
	clrf	DEST
	clrf	DEST+1
	clrf	DEST+2
	clrf	DEST+3
	clrf	DEST+4
	clrf	DEST+5
	ENDM
;................................
DEC2	MACRO	DEST		;
	decf	DEST,F		;zuerst niederes Byte
	incf	DEST,W		;? test auf 0
	btfsc	STATUS,Z	;
	decf	DEST+1,F	;1 ueberlauf
	btfsc	STATUS,Z	;? == 0
	movf	DEST,F		;1 beide Byte == 0 Z setzen
	ENDM

DEC3	MACRO	DEST
	LOCAL	DEC31
	decf	DEST,F
	incf	DEST,W
	bnz	DEC31
	decf	DEST+1,F
	incf	DEST+1,W
	bnz	DEC31
	decf	DEST+2,F
DEC31:
	ENDM

DEC4	MACRO	DEST
	LOCAL	DEC41
	decf	DEST,F
	incf	DEST,W
	bnz	DEC41
	decf	DEST+1,F
	incf	DEST+1,W
	bnz	DEC41
	decf	DEST+2,F
	incf	DEST+2,W
	bnz	DEC41
	decf	DEST+3,F
DEC41:
	ENDM

DEC5	MACRO	DEST
	LOCAL	DEC51
	decf	DEST,F
	incf	DEST,W
	bnz	DEC51
	decf	DEST+1,F
	incf	DEST+1,W
	bnz	DEC51
	decf	DEST+2,F
	incf	DEST+2,W
	bnz	DEC51
	decf	DEST+3,F
	incf	DEST+3,W
	bnz	DEC51
	decf	DEST+4,F
DEC51:
	ENDM
;
INC2	MACRO	DEST
	incf	DEST,F
	btfsc	STATUS,Z
	incf	DEST+1,F
	ENDM

INC3	MACRO	DEST
	INC2	DEST
	btfsc	STATUS,Z
	incf	DEST+2,F
	ENDM

INC4	MACRO	DEST
	INC3	DEST
	btfsc	STATUS,Z
	incf	DEST+3,F
	ENDM

INC5	MACRO	DEST
	INC4	DEST
	btfsc	STATUS,Z
	incf	DEST+4,F
	ENDM
;
INC6	MACRO	DEST
	INC5	DEST
	btfsc	STATUS,Z
	incf	DEST+5,F
	ENDM
;
NEG2	MACRO	DEST
	comf	DEST,F
	comf	DEST+1,F
	incf	DEST,F
	SKPNZ
	incf	DEST+1,F
	ENDM

NEG3	MACRO	DEST
	comf	DEST,F
	comf	DEST+1,F
	comf	DEST+2,F
	INC3	DEST
	ENDM

NEG4	MACRO	DEST
	comf	DEST,F
	comf	DEST+1,F
	comf	DEST+2,F
	comf	DEST+3,F
	INC4	DEST
	ENDM

NEG5	MACRO	DEST
	comf	DEST,F
	comf	DEST+1,F
	comf	DEST+2,F
	comf	DEST+3,F
	comf	DEST+4,F
	INC5	DEST
	ENDM

NEG6	MACRO	DEST
	comf	DEST,F
	comf	DEST+1,F
	comf	DEST+2,F
	comf	DEST+3,F
	comf	DEST+4,F
	comf	DEST+5,F
	INC6	DEST
	ENDM

LDKWD	MACRO	DEST,K
	movlw	HIGH K
	movwf	DEST+1
	movlw	LOW K
	movwf	DEST
	ENDM

LDK2	MACRO	DEST,KH,KL
	movlw	KH
	movwf	DEST+1
	movlw	KL
	movwf	DEST
	ENDM
;
LDK4	MACRO	DEST,KH1,KL1,KH2,KL2
	MOVLF	KH1,DEST+3
	MOVLF	KL1,DEST+2
	MOVLF	KH2,DEST+1
	MOVLF	KL2,DEST
	ENDM

LDK5	MACRO	DEST,KH1,KL1,KH2,KL2,KH3
	MOVLF	KH1,DEST+4
	MOVLF	KL1,DEST+3
	MOVLF	KH2,DEST+2
	MOVLF	KL2,DEST+1
	MOVLF	KH3,DEST
	ENDM

RL2	MACRO	DEST
	rlcf	DEST,F
	rlcf	DEST+1,F
	ENDM
;
RL3	MACRO	DEST
	rlcf	DEST,F
	rlcf	DEST+1,F
	rlcf	DEST+2,F
	ENDM

RL4	MACRO	DEST
	rlcf	DEST,F
	rlcf	DEST+1,F
	rlcf	DEST+2,F
	rlcf	DEST+3,F
	ENDM

RL5	MACRO	DEST
	rlcf	DEST,F
	rlcf	DEST+1,F
	rlcf	DEST+2,F
	rlcf	DEST+3,F
	rlcf	DEST+4,F
	ENDM

RL6	MACRO	DEST
	rlcf	DEST,F
	rlcf	DEST+1,F
	rlcf	DEST+2,F
	rlcf	DEST+3,F
	rlcf	DEST+4,F
	rlcf	DEST+5,F
	ENDM
;
RR2	MACRO	DEST
	rrcf	DEST+1,F
	rrcf	DEST,F
	ENDM

RR3	MACRO	DEST
	rrcf	DEST+2,F
	rrcf	DEST+1,F
	rrcf	DEST,F
	ENDM

RR4	MACRO	DEST
	rrcf	DEST+3,F
	rrcf	DEST+2,F
	rrcf	DEST+1,F
	rrcf	DEST,F
	ENDM

RR5	MACRO	DEST
	rrcf	DEST+4,F
	rrcf	DEST+3,F
	rrcf	DEST+2,F
	rrcf	DEST+1,F
	rrcf	DEST,F
	ENDM

RR6	MACRO	DEST
	rrcf	DEST+5,F
	rrcf	DEST+4,F
	rrcf	DEST+3,F
	rrcf	DEST+2,F
	rrcf	DEST+1,F
	rrcf	DEST,F
	ENDM
;
ADDK4	MACRO	DEST,KH2,KL2,KH1,KL1
	MOVLW	KL1
	ADDWF	DEST
	btfsc	STATUS,C
	incf	DEST+1
	movlw	KH1
	addwf	DEST+1
	btfsc	STATUS,C
	incf	DEST+2
	movlw	KL2
	addwf	DEST+2
	btfsc	STATUS,C
	incf	DEST+3
	movlw	KH2
	addwf	DEST+3
	ENDM

BMUL10	MACRO	DEST
	movlw	.10
	mulwf	DEST
	movff	PRODH,DEST+1
	movff	PRODL,DEST
	ENDM

MOVLFBB macro  literal,dest,banka,bankb
	movlb	banka
	movlw	literal
	movwf	dest
	movlb	bankb
        endm

MOVLF	macro	literal,dest
	movlw	literal
	movwf	dest
	endm

POINT	macro	stringname
	MOVLF	upper stringname, TBLPTRU
	MOVLF	high stringname, TBLPTRH
	MOVLF	low stringname, TBLPTRL
	endm

;;;;;;; Macro definitions ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Stringausgabe aus Code auf Ram ohne Position
RamStr		macro	string
		POINT	string
		call	RString
		endm

;Stringausgabe aus Code auf RS232 ohne Position
rs232Str	macro	string
		POINT	string
		call	rs232String
		endm

;Stringausgabe aus Code auf LCD ohne Position
LCDStr	macro	string
	POINT	string
	call	LCDString
	endm

;Stringausgabe aus Code auf LCD mit Position
LCDStrp	macro	string
	POINT	string
	call	LCDStringp
	endm

;HEX-Ausgabe von 6ByteKonstande auf Zeile 1 
LCDHEX6Z1	macro	var1
		movlw	0
		call	LCDPos
		movf	var1+5,W
		call	LCDHEX
		movf	var1+4,W
		call	LCDHEX
		movf	var1+3,W
		call	LCDHEX
		movf	var1+2,W
		call	LCDHEX
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		endm

;HEX-Ausgabe von 5ByteKonstande auf Zeile 1 
LCDHEX5Z1	macro	var1
		movlw	0
		call	LCDPos
		movf	var1+4,W
		call	LCDHEX
		movf	var1+3,W
		call	LCDHEX
		movf	var1+2,W
		call	LCDHEX
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		call	LCDSpace
		endm

;HEX-Ausgabe von einem DWord auf Zeile 1 
LCDHEX4Z1	macro	var1
		movlw	0
		call	LCDPos
		movf	var1+3,W
		call	LCDHEX
		movf	var1+2,W
		call	LCDHEX
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		call	LCDSpace
		endm

;HEX-Ausgabe von einem DWord auf Zeile 2
LCDHEX4Z2	macro	var1
		movlw	40h
		call	LCDPos
		movf	var1+3,W
		call	LCDHEX
		movf	var1+2,W
		call	LCDHEX
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		call	LCDSpace
		endm

;HEX-Ausgabe von einem Word auf Zeile 1
LCDHEX2Z1	macro	var1
		movlw	0
		call	LCDPos
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		call	LCDSpace
		endm

;HEX-Ausgabe von einem Word auf Zeile 2
LCDHEX2Z2	macro	var1
		movlw	40h
		call	LCDPos
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		call	LCDSpace
		endm

LCDHEX5Z2	macro	var1
		movlw	40h
		call	LCDPos
		movf	var1+4,W
		call	LCDHEX
		movf	var1+3,W
		call	LCDHEX
		movf	var1+2,W
		call	LCDHEX
		movf	var1+1,W
		call	LCDHEX
		movf	var1,W
		call	LCDHEX
		call	LCDSpace
		endm

MOVLF2	macro	literal,dest
	movlw	LOW (literal)
	movwf	dest
	movlw	HIGH (literal)
	movwf	dest+1
	endm

MOVLF3	macro	literal,dest
	movlw	LOW (literal)
	movwf	dest
	movlw	HIGH (literal)
	movwf	dest+1
	movlw	UPPER (literal)
	movwf	dest+2
	endm

MOVLF4	macro	literal,dest
	movlw	LOW (literal)
	movwf	dest
	movlw	HIGH (literal)
	movwf	dest+1
	movlw	UPPER (literal)
	movwf	dest+2
	movlw	literal / 0x1000000
	movwf	dest+3
	endm

CMPK1	MACRO     DEST,KL        ; W:= DEST-W
	MOVLW     KL
	SUBWF     DEST,W
	ENDM

CMPK2	MACRO	DEST,wert	; Low Byte first
	LOCAL	CEND
	MOVLW	HIGH (wert)
	SUBWF	DEST+1,W
	SKPZ
	GOTO	CEND
	MOVLW	LOW (wert)
	SUBWF	DEST,W
CEND	NOP
	ENDM

FGLL	MACRO	wert, freg
	movlw	wert
	cpfseq	freg
	ENDM

FGRL	MACRO	wert, freg
	movlw	wert
	cpfsgt	freg
	ENDM

FKLL	MACRO	wert, freg
	movlw	wert
	cpfslt	freg
	ENDM
